const bench = require('nanobench')
const util = require('../util')
const utilM = require('../util.mom')

let TEST_TIMES = 100000
// TEST_TIMES = 100000
TEST_TIMES = 1

bench.skip('util.addMonth', function (b) {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    util.addMonth(date, 1)
  }
  b.end()
})

bench.skip('util.addQuarter', function (b) {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    util.addQuarter(date, 1)
  }
  b.end()
})

bench.skip('utilM.addMonth', function (b) {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    utilM.addMonth(date, 1)
  }
  b.end()
})

bench.skip('utilM.addQuarter', function (b) {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    utilM.addQuarter(date, 1)
  }
  b.end()
})

// bench('util.convertKey quarter => quarter', function (b) {
//   b.start()
//   for (let i = 0; i < TEST_TIMES; i++) {
//     util.convertKey('2019Q1', 'quarterly')
//   }
//   b.end()
// })


// bench('util.convertKey year => quarter', function (b) {
//   b.start()
//   for (let i = 0; i < TEST_TIMES; i++) {
//     util.convertKey(2019, 'quarterly')
//   }
//   b.end()
// })

// bench('util.convertKey quarter => year', function (b) {
//   b.start()
//   for (let i = 0; i < TEST_TIMES; i++) {
//     util.convertKey('2019Q4', 'annually')
//   }
//   b.end()
// })

// bench('util.convertKey quarter => month', function (b) {
//   b.start()
//   for (let i = 0; i < TEST_TIMES; i++) {
//     util.convertKey('2019Q4', 'monthly')
//   }
//   b.end()
// })

bench.skip('utilM.dateToScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.dateToScopeKey(date, 'annually')
    const quarterly = utilM.dateToScopeKey(date, 'quarterly')
    const monthly = utilM.dateToScopeKey(date, 'monthly')
    const daily = utilM.dateToScopeKey(date, 'daily')
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})

bench.skip('util.dateToScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.dateToScopeKey(date, 'annually')
    const quarterly = util.dateToScopeKey(date, 'quarterly')
    const monthly = util.dateToScopeKey(date, 'monthly')
    const daily = util.dateToScopeKey(date, 'daily')
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})



bench.skip('utilM.dateToNormalizeScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.dateToNormalizeScopeKey(date, 'annually')
    const quarterly = utilM.dateToNormalizeScopeKey(date, 'quarterly')
    const monthly = utilM.dateToNormalizeScopeKey(date, 'monthly')
    const daily = utilM.dateToNormalizeScopeKey(date, 'daily')

    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})

bench.skip('util.dateToNormalizeScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.dateToNormalizeScopeKey(date, 'annually')
    const quarterly = util.dateToNormalizeScopeKey(date, 'quarterly')
    const monthly = util.dateToNormalizeScopeKey(date, 'monthly')
    const daily = util.dateToNormalizeScopeKey(date, 'daily')

    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})


bench.skip('utilM.scopeKeyToDate', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.scopeKeyToDate(2019)
    const quarterly = utilM.scopeKeyToDate('2019Q4')
    const monthly = utilM.scopeKeyToDate('2019-10')
    const daily = utilM.scopeKeyToDate('2019-10-01')

    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})


bench.skip('util.scopeKeyToDate', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.scopeKeyToDate(2019)
    const quarterly = util.scopeKeyToDate('2019Q4')
    const monthly = util.scopeKeyToDate('2019-10')
    const daily = util.scopeKeyToDate('2019-10-01')

    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})


bench.skip('utilM.addScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.addScopeKey(2019, 1)
    const quarterly = utilM.addScopeKey('2019Q4', 1)
    const monthly = utilM.addScopeKey('2019-10', 1)
    const daily = utilM.addScopeKey('2019-10-01', 1)
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})


bench.skip('util.addScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.addScopeKey(2019)
    const quarterly = util.addScopeKey('2019Q4', 1)
    const monthly = util.addScopeKey('2019-10', 1)
    const daily = util.addScopeKey('2019-10-01', 1)
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})

bench.skip('utilM.addNormalizedScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.addNormalizedScopeKey(2019, 1)
    const quarterly = utilM.addNormalizedScopeKey('2019Q4', 1)
    const monthly = utilM.addNormalizedScopeKey('2019-10', 1)
    const daily = utilM.addNormalizedScopeKey('2019-10-01', 1)
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})


bench.skip('util.addNormalizedScopeKey', (b) => {
  const date = new Date()
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.addNormalizedScopeKey(2019)
    const quarterly = util.addNormalizedScopeKey('2019Q4', 1)
    const monthly = util.addNormalizedScopeKey('2019-10', 1)
    const daily = util.addNormalizedScopeKey('2019-10-01', 1)
    // console.log(annually, quarterly, monthly, daily)
  }
  b.end()
})

bench.skip('utilM.generateDates', (b) => {
  const fromDate = new Date(2019, 10, 1)
  const toDate = new Date(2021, 0 ,1)
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = utilM.generateDates(fromDate, toDate, 'monthly')
    // const quarterly = util.compareKey('2019Q4', 1)
    // const monthly = util.compareKey('2019-10', 1)
    // const daily = util.compareKey('2019-10-01', 1)
    // console.log(annually)
  }
  b.end()
})


bench.skip('util.generateDates', (b) => {
  const fromDate = new Date(2019, 9, 31)
  const toDate = new Date(2021, 0 ,1)
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const annually = util.generateDates(fromDate, toDate, 'monthly')
    // const quarterly = util.compareKey('2019Q4', 1)
    // const monthly = util.compareKey('2019-10', 1)
    // const daily = util.compareKey('2019-10-01', 1)
    // console.log(annually, quarterly, monthly, daily)
    // console.log(annually)
  }
  b.end()
})


bench.skip('utilM.getKeysByScope', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    utilM.getKeysByScope('annually')
    utilM.getKeysByScope('quarterly')
    utilM.getKeysByScope('monthly')
    utilM.getKeysByScope('daily')
    // console.log(utilM.keysByScope.daily.slice(-10))
  }
  b.end()
})


bench.skip('util.getKeysByScope', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    util.getKeysByScope('annually')
    util.getKeysByScope('quarterly')
    util.getKeysByScope('monthly')
    util.getKeysByScope('daily')
    // console.log(util.keysByScope.daily.slice(-10))
  }
  b.end()
})


bench.skip('utilM.keysInRange', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const keys = utilM.keysInRange('2015-01', '2020-12')
  }
  b.end()
})


bench.skip('util.keysInRange', (b) => {
  const fromDate = new Date(2019, 9, 31)
  const toDate = new Date(2021, 0 ,1)
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const keys = util.keysInRange('2015-01', '2020-12')
  }
  b.end()
})


const toBeFilledObj = {
  "2018Q3" : 2.31888888888889,
  "2018Q4" : 2.19507936507937,
  "2019Q1" : 2.26396825396825,
  "2019Q2" : 1.54793650793651,
  "2019Q3" : 1.46238095238095,
  "2019Q4" : 1.55603174603175,
  "2020Q1" : 2.43666666666667,
  "2020Q2" : 2.54539682539683,
  "2020Q3" : 2.54539682539683
}
bench.skip('utilM.forwardFillObject', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const result = utilM.forwardFillObject(toBeFilledObj, new Date(2022, 0, 1))
    // console.log(result)
  } 
  b.end()
})

bench.skip('util.forwardFillObject', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const result = util.forwardFillObject(toBeFilledObj, new Date(2022, 0, 1))
    // console.log(result)
  }
  b.end()
})


const toBeFilledArray = [
  {
      "v" : 3.888,
      "seen" : new Date("2021-01-31T00:00:00.000Z"),
      "fk" : "2021",
      "ed" : new Date("2021-12-31T00:00:00.000Z")
  },
  {
      "v" : 4.545,
      "seen" : new Date("2021-02-28T00:00:00.000Z"),
      "fk" : "2021",
      "ed" : new Date("2021-12-31T00:00:00.000Z")
  },
  {
      "v" : 5.355,
      "seen" : new Date("2021-03-31T00:00:00.000Z"),
      "fk" : "2021",
      "ed" : new Date("2021-12-31T00:00:00.000Z")
  },
  {
      "v" : 6,
      "seen" : new Date("2021-04-28T00:00:00.000Z"),
      "fk" : "2021",
      "ed" : new Date("2021-12-31T00:00:00.000Z")
  }
]
const forwardFillOptions = {
  fillToDate: new Date(2022, 0, 1)
}
bench('utilM.forwardFill', (b) => {
  b.start()

  for (let i = 0; i < TEST_TIMES; i++) {
    const result = utilM.forwardFill(toBeFilledArray, forwardFillOptions)
    // console.log(result)
  } 
  b.end()
})

bench('util.forwardFill', (b) => {
  b.start()
  for (let i = 0; i < TEST_TIMES; i++) {
    const result = util.forwardFill(toBeFilledArray, forwardFillOptions)
    // console.log(result)
  }
  b.end()
})

